package tests;

import java.io.*;


public class MessageHeaderUtil {


    /*** Atributos ***/
    private byte[] magic;
    private byte versionMajor;
    private byte versionMinor;
    private byte flags;
    private byte msgType;
    private int msgSize;
    


    public void read(byte[] in) {

	try {

	    DataInputStream dis = new DataInputStream 
		(new ByteArrayInputStream (in, 0, 12));

	
	    // Magic
	    this.magic = new byte[4];
	    for (int i = 0; i < 4; i++)
		magic[i] = dis.readByte();

	    // Version
	    this.versionMajor = dis.readByte();
	    this.versionMinor = dis.readByte();

	    // Flags
	    this.flags = dis.readByte();

	    // MessageType
	    this.msgType = dis.readByte();

	    // MessageSize
	    this.msgSize = dis.readInt();

	    dis.close();

	}
	catch (IOException e) {
	    System.err.println ("Execao de IO: "  + e);
	    e.printStackTrace();
	}

	
	    
	/*** Estrutura do header ***/
	/*
	  org.omg.GIOP.MessageHeader_1_1 result = new org.omg.GIOP.MessageHeader_1_1();
	  result.magic = new char[4];
	  in.read_char_array(result.magic,0,4);
	  result.GIOP_version=org.omg.GIOP.VersionHelper.read(in);
	  result.flags=in.read_octet();
	  result.message_type=in.read_octet();
	  result.message_size=in.read_long();
	  return result;
	
	  // Version
	  org.omg.GIOP.Version result = new org.omg.GIOP.Version();
	  result.major=in.read_octet();
	  result.minor=in.read_octet();
	  return result;
	*/

    }




    public void write(byte[] out) {
    

	if (this.magic == null || this.magic.length < 4) {
	    System.err.println ("Erro de marshal");
	    return;
	}
	    
	try {

	    ByteArrayOutputStream ba = new ByteArrayOutputStream ();

	    DataOutputStream dos = new DataOutputStream 
		(ba);

	    // Magic
	    for (int i = 0; i < 4; i++)
		dos.writeByte(magic[i]);
	
	    // Version
	    dos.writeByte(this.versionMajor);
	    dos.writeByte(this.versionMinor);
	
	    // Flags
	    dos.writeByte(this.flags);
	
	    // MessageType
	    dos.writeByte(this.msgType);
	
	    // MessageSize
	    dos.writeInt(this.msgSize);
	
	    // Escrevendo a saida

	    dos.close();
	    byte[] temp = ba.toByteArray();

	    System.arraycopy (temp, 0, out, 0, temp.length);

	}
	catch (IOException e) {
	    System.err.println ("Execao de IO: "  + e);
	    e.printStackTrace();
	}


	/*** Estrutura do Header ***/
	
	/*
	  out.write_char_array(s.magic,0,4);
	  org.omg.GIOP.VersionHelper.write(out,s.GIOP_version);
	  out.write_octet(s.flags);
	  out.write_octet(s.message_type);
	  out.write_long(s.message_size);
	  
	  // Version
	  out.write_octet(s.major);
	  out.write_octet(s.minor);
	*/
	
    }

    public void setMsgSize (int s) {
	this.msgSize = s;
    }


    public int getMsgSize() {
	return msgSize;
    }



}
