package tests;


import java.io.*;
import java.util.zip.*;


public class MessageUtil {


    private static final int FATOR_COMPRESSAO = 2;


    public static byte[] compressMessage (byte[] buf) {


	try {

	    // Pegamos o header
	    MessageHeaderUtil header = new MessageHeaderUtil();
	    header.read (buf);
	
	
	    // Comprimimos o resto do array....
	    ByteArrayOutputStream os = new ByteArrayOutputStream ();

	    GZIPOutputStream gos = new GZIPOutputStream (os);

	    gos.write (buf, 12, buf.length - 12);

	    gos.close();

	    // ... e guardamos num buffer temporario
	    byte[] temp = os.toByteArray();

	    // Ajustamos o tamanho do cabecalho
	    header.setMsgSize (temp.length);// + 12);


	    // ** Escrevemos tudo de volta **

	    byte[] buf2 = new byte[temp.length + 12];

	    header.write (buf2);
	    System.arraycopy (temp, 0, buf2, 12, temp.length);


	    return buf2;

	} catch (IOException e) {
	    System.err.println ("Erro de IO durante o processo de descompressao: " + e);
	    e.printStackTrace();
	}

	return null;

    }


    public static byte[] decompressMessage (byte[] buf) {


	try {


	    // Pegamos o header
	    MessageHeaderUtil header = new MessageHeaderUtil();
	    header.read (buf);
	
	
	    // Desomprimimos o resto do array.
	    ByteArrayInputStream is = new ByteArrayInputStream (buf, 12, buf.length - 12);

	    GZIPInputStream gis = new GZIPInputStream (is);

	    // Array temporario pra leitura
	    byte[] temp = new byte[header.getMsgSize() * FATOR_COMPRESSAO];

	    // OutputStream com a leitura total
	    ByteArrayOutputStream os = new ByteArrayOutputStream();

	    int bytesRead = 0;

	    while (bytesRead != -1) {

		bytesRead = gis.read (temp, 0, temp.length);
		os.write (temp, 0, bytesRead == -1 ? temp.length : bytesRead);

	    }
	
	    // Neste ponto, temos em os os dados descompactados

	    gis.close(); // Podemos fechar o GZIPInputStream...
	    os.close(); // ... e o os

	    // Ajustamos o tamanho do header da mensagem 
	    header.setMsgSize (os.size()); // + 12);

	    // Comecamos a escrever o buffer de saida

	    byte[] buf2 = new byte[12 + os.size()];
	
	
	    // Colocamos o header la dentro....
	    header.write (buf2);

	    // .. e os dados
	    temp = os.toByteArray();
	    System.arraycopy (temp, 0, buf2, 12, temp.length);

	
	    return buf2;

	} catch (IOException e) {
	    System.err.println ("Erro de IO durante o processo de descompressao: " + e);
	    e.printStackTrace();
	}


	return null;

    }





    private static void compareBuffers (byte[] buf, byte[]buf2) {

	/*** Comparando os buffers ***/
	if (buf.length != buf2.length)
	    System.out.println ("------ Tamanhos diferem ------");
	else {
	    System.out.println ("------ Tamanhos Ok! Prosseguindo... ------");

	    boolean iguais = true;
	    for (int j = 0; j < buf.length; j++)

		if ( (new Byte (buf[j])).compareTo (new Byte (buf2[j])) != 0) {

		    iguais = false;
		    System.out.println ("------ Arrays diferem na posicao " + j + 
					"  ------");
		}
		

	} // of else
	

    }




} // of class
