package tests;

import java.io.*;

import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import java.util.Properties;


public class Server {

    public static void main(String args[]){
	
	if (args.length != 1){
	    System.out.println("Use: jaco tests.Server [file.ior]");
	    System.exit(1);
	}


	/* Precisamos do ORB do JacORB, pois Message Interceptors sao proprietarios */
	jacorb.orb.ORB orb = (jacorb.orb.ORB)org.omg.CORBA.ORB.init(args,null);

	String name = "Tests";

	try {
 
       	    org.omg.PortableServer.POA poa = 
		org.omg.PortableServer.POAHelper.narrow
		(orb.resolve_initial_references("RootPOA"));
	    
	    // The object instantiation.
	    org.omg.CORBA.Object o = 
                poa.servant_to_reference( new TestsImpl() );

	    poa.the_POAManager().activate();
	    
	    // write the object reference to args[0]
	    System.out.println("Not using the NameService");
	    PrintWriter ps = 
		new PrintWriter(new FileOutputStream(new File( args[0] )));
	    ps.println( orb.object_to_string( o ) );
	    ps.close();
	
	   
	    // Registrando o interceptador
	    ServerMessageInterceptor smi = new ServerMessageInterceptor();
	    orb.addServerInterceptor (smi);

            orb.run();
	} catch ( Exception e )
	    {
		e.printStackTrace();
	    }




    }//end of main().
}//end of class.
