package tests;

/**
 * An example message-level interceptor
 * The interceptor reverses the contents of any
 * message after the GIOP message header
 *
 */

import java.io.*;
import jacorb.util.Debug;

public class ServerMessageInterceptor  implements jacorb.orb.ServerMessageInterceptor

{

    /*****************************************************/
    /************* Post Invoke - Compactacao *************/
    /*****************************************************/

    public  byte [] post_invoke( byte [] buf ) {

	System.out.print ("Server.post_invoke: Compressing message............");
	
	byte buf2[] = new byte[buf.length];
	
	
	/* *** Compactacao *** */

	buf2 = MessageUtil.compressMessage (buf);

	// Debug
	/*try {

	    FileOutputStream os = new FileOutputStream ("server_response_compactado");
	    os.write (buf2);
	    os.close();


	    os = new FileOutputStream ("server_response_descompactado");
	    os.write (buf);
	    os.close();
	} catch (IOException e) {
	    System.out.println ("Erro de IO: " + e);
	    e.printStackTrace();
	}
	// **/
	

	System.out.println ("................... done.");
	
	return buf2;
	

    

    }


    /*******************************************************/
    /************* Pre Invoke - Descompactacao *************/
    /*******************************************************/

    
    public  byte [] pre_invoke( byte [] buf ) {
	
	System.out.print ("Server.pre_invoke: Decompressing message ..............");
	
	byte buf2[] = new byte[buf.length];

	/* ****** Descompactacao ***** */


	buf2 = MessageUtil.decompressMessage (buf);


	// Debug
	/*try {

	    FileOutputStream os = new FileOutputStream ("server_request_descompactado");
	    os.write (buf2);
	    os.close();


	    os = new FileOutputStream ("server_request_compactado");
	    os.write (buf);
	    os.close();
	} catch (IOException e) {
	    System.out.println ("Erro de IO: " + e);
	    e.printStackTrace();
	}
	// **/
	
	
	System.out.println ("..................done");
	
	return buf2;
	
	
    }
    
    
} // of class


    
