
import java.io.*;
import java.util.zip.*;

public class CompressFile {


    public static final int TAM_BUFFER_TEMP = 300000;
    
    public static void main (String args[]) {

	if (args.length < 1) {
	    System.out.println ("Usage: java CompressFile <file>");
	    System.exit (0);
	}


	/** O arquivo de entrada **/

	FileInputStream in = null;

	try {
	    in = new FileInputStream (args[0]);
	}
	catch (IOException e) {
	    System.out.println ("Nao foi possivel abrir o arquivo: " + args[0]);
	    System.exit(0);
	}

	System.out.print ("Compressing file " + args[0] + " to " + 
			    args[0] + ".gz ...................");
	
	/** Nosso arquivo de saida (compactado) **/
	try {
	    GZIPOutputStream out = new GZIPOutputStream 
		(new FileOutputStream (args[0] + ".gz"));

	    byte[] temp = new byte[TAM_BUFFER_TEMP];

	    int bytesRead = 0;
	    while (bytesRead != -1) {
		
		bytesRead = in.read (temp);
		if (bytesRead != -1)
		    out.write (temp, 0, bytesRead);

	    }

	    out.close();
	    

	    System.out.println (".............................. done.");

	} // of try
	catch (IOException e) {
	    System.out.println ("Erro de IO: " + e);
	    System.exit(0);
	}


    } // of main





} // of class
